# coding=utf-8

"""Configuration for waf"""

import os.path as osp

def configure(self):
    opts = self.options
    if 'verbose=True'.strip():
        self.env.append_value('OPT_ENV', 'verbose=True'.splitlines())

    self.env['FC'] = 'gfortran48'
    self.env['CC'] = 'cc'
    # to check med libs
    self.env['CXX'] = 'c++'
    # sometimes required
    self.env.append_unique('LINKFLAGS', ['-Wl,--allow-multiple-definition'])

    self.env.append_value('LIBPATH', [
        '/usr/local/lib',
        '/usr/local/lib',
        '/usr/local/lib',
        '/usr/local/lib',
        '/usr/local/lib',
        '/usr/local/lib',
        # autotools uses lib64 on some platforms
        '/usr/local/lib64',
        '/usr/local/lib64',
    ])

    self.env.append_value('INCLUDES', [
        '/usr/local/include',
        '/usr/local/include',
        '/usr/local/include',
        '/usr/local/include',
    ])

    self.env['OPTLIB_FLAGS'] = '-L/usr/local/lib -lblas -llapack   -Wl,-rpath=/usr/local/lib/gcc48  -L/usr/local/lib/gcc48 -B/usr/local/bin -L/usr/local/lib -fstack-protector -lgfortran -lm -lkvm'.split()         + '-Xlinker -export-dynamic -lutil -lpthread -lz'.split()
    opts.maths_libs = ''

    opts.enable_petsc = False

